SELECT
  'dynamic' as component,
  sqlpage.run_sql('cookie.sql') AS properties
;

SELECT 'shell' AS component,
  'dark' AS theme,
  'Tags' AS title
;

SELECT
  'dynamic' as component,
  sqlpage.run_sql('nav.sql') AS properties
;

SELECT
  'table' AS component,
  TRUE AS search,
  TRUE AS striped_rows,
  TRUE AS small,
  'Notice' AS markdown
;

DROP TABLE IF EXISTS sqlpage_tags;
CREATE TEMPORARY TABLE IF NOT EXISTS sqlpage_tags AS (
SELECT * FROM (SELECT count(DISTINCT txn.id) AS "Uses", tg.name AS "Name"
FROM tags tg
JOIN tags_map tm ON tg.id = tm.tag_id
JOIN transactions txn ON txn.id = tm.transaction_id
JOIN products p ON p.id = txn.product_id
JOIN categories c ON p.category_id = c.id
JOIN groups g ON c.group_id = g.id
JOIN sqlpage_options op ON op.type = 'product' AND p.name = op.name
JOIN sqlpage_options oc ON oc.type = 'category' AND c.name = oc.name
JOIN sqlpage_options og ON og.type = 'group' AND g.name = og.name
JOIN sqlpage_options ot ON ot.type = 'tag' AND tg.name = ot.name
WHERE 
  COALESCE(op.selected, oc.selected, og.selected, TRUE)
AND
  COALESCE(ot.selected, TRUE)
AND
  op.session = sqlpage.cookie('session')
AND
  oc.session = sqlpage.cookie('session')
AND
  og.session = sqlpage.cookie('session')
AND
  ot.session = sqlpage.cookie('session')
AND
  ((ts AT TIME ZONE 'UTC') AT TIME ZONE 'Pacific/Auckland')::date
  BETWEEN (
    SELECT name FROM sqlpage_options WHERE type = 'start'
  )::date AND (
    SELECT name FROM sqlpage_options WHERE type = 'end'
  )::date
GROUP BY tg.name
ORDER BY 1 DESC, 2) q
UNION ALL
SELECT count(DISTINCT txn.id) AS "Uses", count(DISTINCT tg.name)||'' AS "Name"
FROM tags tg
JOIN tags_map tm ON tg.id = tm.tag_id
JOIN transactions txn ON txn.id = tm.transaction_id
JOIN products p ON p.id = txn.product_id
JOIN categories c ON p.category_id = c.id
JOIN groups g ON c.group_id = g.id
JOIN sqlpage_options op ON op.type = 'product' AND p.name = op.name
JOIN sqlpage_options oc ON oc.type = 'category' AND c.name = oc.name
JOIN sqlpage_options og ON og.type = 'group' AND g.name = og.name
JOIN sqlpage_options ot ON ot.type = 'tag' AND tg.name = ot.name
WHERE
  COALESCE(op.selected, oc.selected, og.selected, TRUE)
AND
  COALESCE(ot.selected, TRUE)
AND
  op.session = sqlpage.cookie('session')
AND
  oc.session = sqlpage.cookie('session')
AND
  og.session = sqlpage.cookie('session')
AND
  ot.session = sqlpage.cookie('session')
AND
  ((ts AT TIME ZONE 'UTC') AT TIME ZONE 'Pacific/Auckland')::date
  BETWEEN (
    SELECT name FROM sqlpage_options WHERE type = 'start'
  )::date AND (
    SELECT name FROM sqlpage_options WHERE type = 'end'
  )::date
);
SELECT * FROM sqlpage_tags;

SELECT 
  '# No Data' AS "Notice"
WHERE NOT EXISTS(SELECT * FROM sqlpage_tags LIMIT 1);
